package sfm.dataset;

import java.io.Serializable;

/**
 *  ONE 'ExpandedPattern' per attribute, thus
 *  ONE double[] per attribute.
 *  
 *   That is, 'Instance.getExpandedNeuralNetData()' returns an array of this class.
 */
public final class ExpandedPattern implements Serializable
{
  private double[] attributePattern;
  
  public ExpandedPattern(double[] pat)
  {
    attributePattern = pat;
  }
//------------------------------------------------------------------------//
  public ExpandedPattern(String bitStr)
  {
    attributePattern = new double[bitStr.length()];
    
    for (int i=0; i < bitStr.length(); i++)
    {
      if (bitStr.charAt(i) == '0')
      {
        attributePattern[i] = 0.0;
      }
      else if (bitStr.charAt(i) == '1')
      {
        attributePattern[i] = 1.0;
      }
      else
      {
        System.out.println("ExpandedPattern() : invalid bitString  = " + bitStr);
      }
    }
    
    // for (int i=0; i < bitStr.length(); i++) System.out.print(attributePattern[i] + " ");
    // System.out.println("----------");
  }
//------------------------------------------------------------------------// 
  public void XsetPattern(double[] pat)
  {
    attributePattern = pat;
  }
  //------------------------------------------------------------------------//  
  public double[] getPattern()
  {
    return attributePattern;
  }
//------------------------------------------------------------------------//
}