package sharkey_mod_nlp.dataset;

import java.io.Serializable;

/**
 * Container class for 1 word (lexeme) and its relevant POS fields.
 */
public final class Lexeme implements Serializable
{
  private String lexeme, strBitmask; 
  private int posBitmask, lexemeID;
  private int[] posBits;
  
  public Lexeme(String lex, int posMask, int[] bits, int id, String strBitmask)
  {
    this.lexeme     = lex;
    this.posBitmask = posMask;
    this.lexemeID   = id;
    this.strBitmask = strBitmask;
    
    /*
    System.out.println("bitmask for " + lex);
    for (int i=0; i < bits.length; i++) System.out.print(bits[i] + " ");
    System.out.println("");
    */
    
    posBits = bits;
  }
//----------------------------------------------------------//
  public boolean hasPOSbitSet(int bit)
  {
    if (posBits[bit] == 1)
    {
      /*
      System.out.println(lexeme + " has bit #" + bit + " set!");      
      for (int i=0; i < posBits.length; i++) System.out.print(posBits[i] + " ");
      System.out.println();
      */
      
      return true;
    }
    return false;
  }
//----------------------------------------------------------//
  /**
   * returns the word number of this lexeme
   */
  public int getID()          { return lexemeID;   }
  public int getPOS_bitmasx() { return posBitmask; }
  public String getLexeme()   { return lexeme;     }
  public String getBitmask()  { return strBitmask; }
}
//----------------------------------------------------------//