package sharkey_mod_nlp.dataset.loaders;

import java.util.*;
import sharkey_mod_nlp.dataset.*;
import sharkey_mod_nlp.dataset.input.*;
import sharkey_mod_nlp.treemodel.*;
//import sfm.nativecode.*;

public final class Loader_Sentences
{
//------------------------------------------------------------//  
  public static Dataset loadDataset()
  {
    Instance.resetInstanceCounter(); // IMPORTANT, just in case...
    
    String data   = "datasets/language/sentences.data";
    String pos    = "datasets/language/sentences.pos";
    String dic    = "datasets/language/sentences.lexicon";
    String lookup = "datasets/language/sentences.lookup";
    
    Vector<String> rawData      = ReadFile.readDatasetFromFile(data);
    Vector<String> rawPOS       = ReadFile.readDatasetFromFile(pos);
    Vector<String> rawDIC       = ReadFile.readDatasetFromFile(dic);
    Vector<String> rawStructure = ReadFile.readDatasetFromFile(lookup);

    Dataset dataset = new Dataset("Modular NLP", 8);
    dataset.setClassNames(new String[] {"0", "1", "2", "3", "4", "5", "6", "7"});
    
    ParseNode.setNumberOfBitsON(2); // 2 of 12 bits are ALWAYS on for TERMINAL NODES
    
    Parser.parseData(dataset, rawData, ",");
    Parser.parsePOS(dataset, rawPOS, ",");
    Parser.parseDIC(dataset, rawDIC, ",", 12);
    Parser.parsePreStructuredInput(dataset, rawStructure, ",");
    
    dataset.compile(12); // using 12bit patterns
    
    return dataset;
  }
//------------------------------------------------------------//
//------------------------------------------------------------//
}