package sharkey_mod_nlp.fnn;

import java.io.Serializable;

public final class Link implements Serializable
{
  private Neuron inNeuron, outNeuron;
  private double weight, min, max;
  private boolean enforceBounds;
  
  public double prevChange, cumChange;
  private int cntr;
//------------------------------------------------//
  public Link(double wt, boolean enforceBounds)
  {
    this.weight = wt; 
    this.enforceBounds = enforceBounds; 
  }
//------------------------------------------------//
  public void setInNeuron(Neuron in)
  {
    this.inNeuron = in;
  }
//------------------------------------------------//
  public void setOutNeuron(Neuron out)
  {
    this.outNeuron = out;
  }
//------------------------------------------------//
  public Neuron getInNeuron()
  {
    return inNeuron;
  }
//------------------------------------------------//  
  public Neuron getOutNeuron()
  {
    return outNeuron;
  }
//------------------------------------------------//
  /**
   * Sets the upper and lower bounds for weights.
   * The params are inclusive.
   */
  public void setWeightBounds(double min, double max)
  {
    this.min = min;
    this.max = max;
  }
//------------------------------------------------// 
  public double getWeight()
  {
    return weight;
  }
//------------------------------------------------//
  public void updateWeight(double dWt)
  {
    if (enforceBounds)
    {
      if (weight + dWt > max) return;
      if (weight + dWt < min) return;
    }
    
    weight += dWt;
  }
//-------------------------------------------------------//
  public final void cumulateChanges(double change)
  {
    cumChange += change;
    cntr++;
  }
//-------------------------------------------------------//
  public final void realizeChanges()
  {
    prevChange = (cumChange / cntr);
    weight    += prevChange;
    
    cumChange = 0;
    cntr      = 0;
  }
//-------------------------------------------------------//  
}
