package sharkey_mod_nlp.fnn.raam;

import java.util.*;
import java.io.*;
import sharkey_mod_nlp.treemodel.ParseNode;


public class ParseTreeData implements Serializable
{
  private Vector<ParseNode>[] parseTreeData;
  private int syntacticStructureID;
  private ParseNode root;
  
  public ParseTreeData(Vector<ParseNode>[] v)
  {
    parseTreeData        = v;
    syntacticStructureID = parseTreeData[0].elementAt(0).getSyntacticStructureID();
    root                 = parseTreeData[0].elementAt(0);
  }
//-----------------------------------------------------//
  public int getSyntacticClass()
  {
    return syntacticStructureID;
  }
//-----------------------------------------------------//
  public ParseNode getRoot()
  {
    return root;
  }
//-----------------------------------------------------//
  public int getPlyDepth()
  {
    return parseTreeData.length;
    // return parseTreeData[0].elementAt(0).getMaxPlyDepth();
  }
//-----------------------------------------------------//
  public Vector<ParseNode>[] getParseTreeData()
  {
    return parseTreeData;
  }
//-----------------------------------------------------//
}
