package sharkey_mod_nlp.gui;

import java.awt.event.*;
import java.awt.*;

import javax.swing.*;
import javax.swing.border.*;

import java.util.*;

import sharkey_mod_nlp.dataset.Dataset;
import sharkey_mod_nlp.dataset.Instance;
import sharkey_mod_nlp.dataset.loaders.*;
import sharkey_mod_nlp.fnn.*;
import nasseutils.NasseBox;

public class GUI_ANN extends JPanel implements ActionListener, ItemListener
{
  protected Dataset dataset;
  protected ANNConfig annConfig;
  private FNN nm;
  
  private Vector<JTextField> annCfgV;
  protected JTextArea jtA_out;
  protected JTextField tf_Epochs, tf_preEpochs, tf_inputNodes, tf_hiddenNodes, tf_outputNodes;
  protected JTextField tfTrainRatio, tfTrainSamps, tfTestSamps;
  protected JTextField tf_margin, tf_Learningrate, tf_Momentum, tf_Noise; 
  
  private JPanel attributePanel;
  
  private JProgressBar progressBar;
  protected JButton trainButt, testButt, loaderButt_sentences;
  protected JButton saveButt, loadButt, createNetworkButt;
  
  public GUI_ANN()
  {
    annCfgV   = new Vector<JTextField>();
    annConfig = new ANNConfig();
    
    //////////////////////////////////////////////////////////////////////////////////////
    ///// attributes panel - enable diff reduction (transform to a small set of integers)
    attributePanel = new JPanel();
    JPanel jpWest = new JPanel(new BorderLayout());    
    jpWest.add(attributePanel, BorderLayout.EAST);
    
    //  ------- checkbox
    /*
    JCheckBox cb_force = new JCheckBox("Run until successful", false); 
    cb_force.addItemListener(this);
    cb_force.setName("forcerun");
    */
    
    JCheckBox cb_updating = new JCheckBox("Update weights per epoch", false); 
    cb_updating.addItemListener(this);
    cb_updating.setName("update_pr_epoch");
    
    JCheckBox cb_prestructure = new JCheckBox("Enable prestructuring", true); 
    cb_prestructure.addItemListener(this);
    cb_prestructure.setName("prestructuring");

    JPanel cb_updatingP = new JPanel(new GridLayout(1,1));
    cb_updatingP.add(cb_prestructure);
    cb_updatingP.add(cb_updating);
    
    //------- checkbox
    
    createNetworkButt = new JButton("Create Network!");
    createNetworkButt.setActionCommand("makenetwork");
    createNetworkButt.addActionListener(this);
    
    trainButt = new JButton("Train");
    trainButt.setActionCommand("start_training");
    trainButt.addActionListener(this);
    trainButt.setEnabled(false);
    
    testButt = new JButton("Test");
    testButt.setActionCommand("start_testing");
    testButt.addActionListener(this);
    testButt.setEnabled(false);

    ////////////////////////////////////////
    /// create gui for the dataset-loaders
    JPanel loaderPanelX = new JPanel(new GridLayout(2, 1, 4, 2));
    
    loaderButt_sentences = new JButton("Load \"Sentences\" dataset");
    loaderButt_sentences.setActionCommand("load_sentences");
    loaderButt_sentences.addActionListener(this);
    
    loaderPanelX.add(loaderButt_sentences);
    
    JPanel loaderP = new JPanel(new FlowLayout(FlowLayout.LEFT));
    loaderP.add(loaderPanelX);
    
    JPanel buttP = new JPanel();
    buttP.add(createNetworkButt);
    buttP.add(trainButt);
    buttP.add(testButt);
    
    JPanel trainButtP = new JPanel(new BorderLayout());
    JLabel dummyL3 = new JLabel("-"); dummyL3.setForeground(trainButtP.getBackground());
    
    // trainButtP.add(dummyL3, BorderLayout.NORTH);
    trainButtP.add(loaderP, BorderLayout.NORTH);
    trainButtP.add(buttP, BorderLayout.WEST);
    
    tf_Epochs       = new JTextField("100");
    tf_preEpochs    = new JTextField("4000");
    tf_margin       = new JTextField("0.1");
    tf_Learningrate = new JTextField("0.25");
    tf_Momentum     = new JTextField("0.65");
    tf_Noise        = new JTextField("0.00");
    tf_Noise.setEditable(false);
    
    tf_inputNodes   = new JTextField("");
    tf_hiddenNodes  = new JTextField("");
    tf_outputNodes  = new JTextField("");
    
    // tf_inputNodes.setEditable(false);
    // tf_outputNodes.setEditable(false);
    tf_margin.setToolTipText("The strength of classification: its value is the lowest accepted output for each pattern...");
    
    progressBar = new JProgressBar(0,0);
    
    tf_Learningrate.setBorder(new BevelBorder(BevelBorder.LOWERED));
    tf_margin.setBorder(new BevelBorder(BevelBorder.LOWERED));
    tf_Momentum.setBorder(new BevelBorder(BevelBorder.LOWERED));
    tf_Noise.setBorder(new BevelBorder(BevelBorder.LOWERED));
    tf_Epochs.setBorder(new BevelBorder(BevelBorder.LOWERED));
    tf_preEpochs.setBorder(new BevelBorder(BevelBorder.LOWERED));
    
    JPanel cfgPanel = new JPanel(new GridLayout(13,2));
    cfgPanel.add(new JLabel("Margin"));			      cfgPanel.add(tf_margin);
    cfgPanel.add(new JLabel("Epochs"));			      cfgPanel.add(tf_Epochs);
    cfgPanel.add(new JLabel("Prestructuring"));   cfgPanel.add(tf_preEpochs);
    
    cfgPanel.add(new JLabel("Learning rate"));	  cfgPanel.add(tf_Learningrate);
    cfgPanel.add(new JLabel("Momentum"));			    cfgPanel.add(tf_Momentum);
    cfgPanel.add(new JLabel("Noise"));			      cfgPanel.add(tf_Noise);    
    cfgPanel.add(new JLabel(""));			            cfgPanel.add(new JLabel(""));
    cfgPanel.add(new JSeparator());			          cfgPanel.add(new JSeparator());
    
    cfgPanel.add(new JLabel("Input nodes   "));	   cfgPanel.add(tf_inputNodes);
    cfgPanel.add(new JLabel("Hidden nodes  "));	   cfgPanel.add(tf_hiddenNodes);
    cfgPanel.add(new JLabel("Output nodes  "));	   cfgPanel.add(tf_outputNodes);
    
    cfgPanel.add(new JLabel(""));			            cfgPanel.add(new JLabel(""));
    cfgPanel.add(new JLabel("Progress  "));       cfgPanel.add(progressBar);
    
    NasseBox nb = new NasseBox(null);
    nb.add(cfgPanel);

    JPanel wrapP = new JPanel(new BorderLayout(30,10));
    wrapP.add(cb_updatingP, BorderLayout.NORTH);
    wrapP.add(nb, BorderLayout.CENTER);    
    wrapP.add(trainButtP, BorderLayout.SOUTH);    
    // wrapP.add(loaderP, BorderLayout.EAST);
    
    /////////////////////////////////////
    ///// the output tray....
    jtA_out = new JTextArea(10,75);
    jtA_out.setBorder(new BevelBorder(BevelBorder.LOWERED));
    JScrollPane jsp = new JScrollPane(jtA_out, JScrollPane.VERTICAL_SCROLLBAR_ALWAYS, JScrollPane.HORIZONTAL_SCROLLBAR_NEVER);
    
    JPanel outputP = new JPanel(new BorderLayout(2,10));
    outputP.add(new JSeparator(), BorderLayout.NORTH);
    outputP.add(new JLabel("Actual classifications & MSE for dataset"), BorderLayout.WEST);
    outputP.add(jsp, BorderLayout.SOUTH);
    
    JPanel wrapCfg = new JPanel(new FlowLayout(FlowLayout.LEFT));
    wrapCfg.add(wrapP);
    
    JPanel bothP = new JPanel(new BorderLayout(10,16));
    bothP.add(jpWest, BorderLayout.WEST);
    bothP.add(wrapCfg, BorderLayout.EAST);
    bothP.add(outputP, BorderLayout.SOUTH);
    
    this.setLayout(new FlowLayout(FlowLayout.LEFT));
    this.add(bothP);
    
    saveButt = new JButton("Save Network");
    saveButt.setActionCommand("save");
    saveButt.addActionListener(this);
    
    loadButt = new JButton("Load Network");
    loadButt.setActionCommand("getfromfile");
    loadButt.addActionListener(this);
    
    this.add(saveButt);
    this.add(loadButt);
    
    annCfgV.addElement(tf_margin);
    annCfgV.addElement(tf_Epochs);
    annCfgV.addElement(tf_preEpochs);
    annCfgV.addElement(tf_Learningrate);
    annCfgV.addElement(tf_Momentum);
    annCfgV.addElement(tf_Noise);
    annCfgV.addElement(tf_inputNodes);
    annCfgV.addElement(tf_hiddenNodes);
    annCfgV.addElement(tf_outputNodes);
    
    tf_margin.setName("margin");
    tf_Epochs.setName("epochs");
    tf_preEpochs.setName("pre_epochs");
    tf_Learningrate.setName("learningrate");
    tf_Momentum.setName("momentum");
    tf_Noise.setName("noise");    
    tf_inputNodes.setName("inputnodes");
    tf_hiddenNodes.setName("hiddennodes");
    tf_outputNodes.setName("outputnodes");
    
    // tf_inputNodes.setText("50");
    // tf_hiddenNodes.setText("35");
    // tf_outputNodes.setText("12");
  }
//-----------------------------------------------------------------//
  /**
   * This method may only be called AFTER a dataset has been loaded!
   */
  private JPanel createDatasetPanel()
  {
    ///////////////////////////////////////////////////////
    JLabel tfdatasetName     = new JLabel(dataset.getName());
    JTextField tfdatasetSize = new JTextField("" + dataset.getNumberOfInstances());
    JTextField tfdatasetAtrs = new JTextField("" + dataset.getNumberOfAttributes());
    JTextField tfdatasetCls  = new JTextField("" + dataset.getNumberOfClasses());    
    
    tfTrainSamps  = new JTextField();    
    tfTestSamps   = new JTextField();    
    tfTrainRatio  = new JTextField("0.75", 4);
    
    tfTrainSamps.setEditable(false);
    tfTestSamps.setEditable(false);
    
    tfdatasetSize.setEditable(false);
    tfdatasetAtrs.setEditable(false);
    tfdatasetCls.setEditable(false);
    
    tfdatasetName.setFont(new Font("Courier New", Font.BOLD, 12));    
    JLabel dName = new JLabel("Dataset = ");
    dName.setFont(new Font("Courier New", Font.BOLD, 12));
    
    JPanel infoPanel = new JPanel(new GridLayout(9,2));
    
    infoPanel.add(dName);
    infoPanel.add(tfdatasetName);

    JLabel invis0 = new JLabel("invisible");
    invis0.setForeground(infoPanel.getBackground());    
    JLabel invis00 = new JLabel("invisible");
    invis00.setForeground(infoPanel.getBackground());
    infoPanel.add(invis0);    
    infoPanel.add(invis00);
    
    infoPanel.add(new JLabel("Training Ratio"));
    infoPanel.add(tfTrainRatio);
    
    infoPanel.add(new JLabel("Instances"));
    infoPanel.add(tfdatasetSize);
    
    infoPanel.add(new JLabel("Attributes"));
    infoPanel.add(tfdatasetAtrs);
    
    infoPanel.add(new JLabel("Classes"));
    infoPanel.add(tfdatasetCls);

    JLabel invis1 = new JLabel("invisible");
    invis1.setForeground(infoPanel.getBackground());    
    JLabel invis11 = new JLabel("invisible");
    invis11.setForeground(infoPanel.getBackground());
    infoPanel.add(invis1);    
    infoPanel.add(invis11);
    
    infoPanel.add(new JLabel("Training size"));
    infoPanel.add(tfTrainSamps);
    
    infoPanel.add(new JLabel("Testing size"));
    infoPanel.add(tfTestSamps);
    
    // c = tfTrainRatio.getBackground();
    
    JPanel infoWrap = new JPanel(new FlowLayout(FlowLayout.LEFT));
    infoWrap.add(infoPanel);
    //------------------------------------------
    
    JPanel jspView = new JPanel(new BorderLayout());
    jspView.setBorder(new BevelBorder(BevelBorder.LOWERED));    
    jspView.add(infoWrap, BorderLayout.NORTH);
    
    return jspView;
  }
//---------------------------------------------------------------------//
  public void clearOutput()
  {
    jtA_out.setText("");
  }
//---------------------------------------------------------------------//
  public void print(String s)
  {
    jtA_out.append(s);
  } 
//---------------------------------------------------------------------//
  public void showProgress(int progressValue)
  {
    progressBar.setValue(progressValue);
  }
//---------------------------------------------------------------------//  
  public void notify_finished()
  {
    trainButt.setEnabled(true);
    progressBar.setValue(0);
  }
//---------------------------------------------------------------------//  
  public void actionPerformed(ActionEvent e)
  {
    String cmd = e.getActionCommand();
    
    if (cmd.equalsIgnoreCase("makenetwork"))
    {
      if (parseInputfields())
      {
        trainButt.setEnabled(true);

        // NB! Very application specific ANN code here;
        // -> give the inputPatterns for the FNN mapper-module. 
        // Also, we need to give the training-target patterns:
        // These are the top-patterns generated when training the RAAM decoder, one pattern
        // for each (syntactic structure) class.
        Vector<Instance> srnOutput = NetworkPool.getEncoderNetwork().getCompressedPatterns();
        annConfig.getDataset().setInstances(srnOutput);
        
        nm = new FNN(this, annConfig);
        NetworkPool.setMapperNetwork(nm);
        
        Vector<Instance> trainingTargets = NetworkPool.getDecoderNetwork().getTopLevelPatterns();
        nm.setTrainingTargets(trainingTargets);
      }
    }    
    else if (cmd.equalsIgnoreCase("start_training"))
    {
      if (parseInputfields())
      {
        trainButt.setEnabled(false);
        
        nm.startTraining();
        
        if (nm.getNumberOfTestingSamples() > 0) testButt.setEnabled(true);
        
        tfTrainSamps.setText(nm.getNumberOfTrainingSamples() + "");
        tfTestSamps.setText(nm.getNumberOfTestingSamples() + "");
      }
    }
    else if (cmd.equalsIgnoreCase("start_testing"))
    {
      if (parseInputfields())
      {
        nm.startTesting();
      }
    }
    else if (cmd.startsWith("load"))
    {
      loadDataset(cmd);
      this.tf_inputNodes.setText("50");
      this.tf_hiddenNodes.setText("35");
      this.tf_outputNodes.setText("12");
    }
    else if (cmd.startsWith("save"))
    {
      nm.saveMe("save/mapper");
    }
    else if (cmd.startsWith("getfromfile"))
    {
      trainButt.setEnabled(true);
      
      nm        = new FNN(this);
      annConfig = nm.loadMe("save/mapper");
      
      Vector<Instance> srnOutput = NetworkPool.getEncoderNetwork().getCompressedPatterns();
      annConfig.getDataset().setInstances(srnOutput);
      
      Vector<Instance> trainingTargets = NetworkPool.getDecoderNetwork().getTopLevelPatterns();
      nm.setTrainingTargets(trainingTargets);

      setLoadedConfig();
      NetworkPool.setMapperNetwork(nm);
    }
  }
//---------------------------------------------------------------------//
  protected void setLoadedConfig()
  {
    // Dataset is static, and NOT saved to file - set it
    if (dataset != null) annConfig.setDataset(dataset);
    
    tf_inputNodes.setText(annConfig.getInputNodes()   + "");
    tf_hiddenNodes.setText(annConfig.getHiddenNodes() + "");
    tf_outputNodes.setText(annConfig.getOutputNodes() + "");
    tf_Epochs.setText(annConfig.getEpochs() + "");
    tf_margin.setText(annConfig.getMargin() + "");
    tf_Learningrate.setText(annConfig.getLearningR() + "");
    tf_Momentum.setText(annConfig.getMomentum() + "");
    tf_Noise.setText(annConfig.getNoise() + "");
  }
//---------------------------------------------------------------------//
  protected void loadDataset(String name)
  {
    if (name.equalsIgnoreCase("load_sentences"))
    {
      dataset = Loader_Sentences.loadDataset();
      
      trainButt.setEnabled(true);
      loaderButt_sentences.setEnabled(false);
      testButt.setEnabled(false);
    }
    
    annConfig.setDataset(dataset);
    
    // tf_outputNodes.setText(dataset.getNumberOfClasses() + "");
    //-----------------------------------
    
    JPanel parent = (JPanel) attributePanel.getParent();
    parent.remove(attributePanel);
    attributePanel = createDatasetPanel();
    parent.add(attributePanel, BorderLayout.WEST);
    this.paintAll(this.getGraphics());
    
    clearOutput();
    print("Loaded dataset '" + dataset.getName() + "'...\n");
  }
//---------------------------------------------------------------------//  
  public void itemStateChanged(ItemEvent e)
  {
    if (e.getSource() instanceof JCheckBox)
    {
      JCheckBox cb = (JCheckBox) e.getSource();
      
      if (cb.getName().equalsIgnoreCase("forcerun"))
      {
        if (e.getStateChange() == ItemEvent.DESELECTED)
        {
          annConfig.setRunUntilSuccessful(false);
          tf_Epochs.setEnabled(true);
        }
        else
        {
          annConfig.setRunUntilSuccessful(true);
          tf_Epochs.setEnabled(false);
        }
      }
      else if (cb.getName().equalsIgnoreCase("update_pr_epoch"))
      {
        if (e.getStateChange() == ItemEvent.DESELECTED)
        {
          annConfig.setUpdateWeightsPerEpoch(false);          
        }
        else
        {
          annConfig.setUpdateWeightsPerEpoch(true);
        }
      }
      else if (cb.getName().equalsIgnoreCase("prestructuring"))
      {
        if (e.getStateChange() == ItemEvent.DESELECTED)
        {
          annConfig.setUsePrestructuring(false);          
        }
        else
        {
          annConfig.setUsePrestructuring(true);
        }
      }
    }
  }  
//---------------------------------------------------------------------//
  /**
   * Parses all textfields and sets the corresponding values in the config
   * template for our ANN; ANNConfig.
   * All flags from checkboxes are updated on-the-fly... 
   */
  protected boolean parseInputfields()
  {
    JTextField tf = null;
    
    try
    {
      for (int i=0; i < annCfgV.size(); i++)
      {
        tf = annCfgV.elementAt(i);
        if (!tf.isEnabled()) continue;
        
        double value = Double.parseDouble(tf.getText().trim());
        
        boolean ok = annConfig.setValueFor(tf.getName(), value);        
        tf.setBackground(Color.WHITE);
        
        // some buggy stuff; tried to set the value for a named target that were NOT found, stop.
        if (!ok) return false;
      }
    }
    catch (NumberFormatException e)
    {
      if (tf != null) tf.setBackground(Color.PINK);
      return false;
    }
    
    progressBar.setMinimum(0);
    progressBar.setMaximum(annConfig.getEpochs());
    
    ////////////////////////////////
    double trainRatio = 0.75;
    
    try
    {
      trainRatio = Double.parseDouble(tfTrainRatio.getText().trim());
    }
    catch (NumberFormatException ex) 
    {
      tfTrainRatio.setText("<invalid>");
      // tfTrainRatio.setBackground(Color.PINK);
    }
    
    annConfig.setTrainingRatio(trainRatio);
    
    return true;
  }
//---------------------------------------------------------------------//  
}