package sharkey_mod_nlp.gui;

import java.awt.event.ActionEvent;
import sharkey_mod_nlp.fnn.*;

public class GUI_RAAM extends GUI_ANN
{
  private RAAM raam;
  
  public GUI_RAAM()
  {
    tf_inputNodes.setText("36");
    tf_hiddenNodes.setText("12");
    tf_outputNodes.setText("36");
    
    tf_inputNodes.setEditable(true);
    tf_hiddenNodes.setEditable(true);
    tf_outputNodes.setEditable(true);
  }
//---------------------------------------------------------------------//  
  public void actionPerformed(ActionEvent e)
  {
    String cmd = e.getActionCommand();
    
    if (cmd.equalsIgnoreCase("makenetwork"))
    {
      if (parseInputfields())
      {
        trainButt.setEnabled(true);
        
        raam = new RAAM(this, annConfig);
        NetworkPool.setDecoderNetwork(raam);
      }
    }
    else if (cmd.equalsIgnoreCase("start_training"))
    {
      if (parseInputfields())
      {
        trainButt.setEnabled(false);
        
        raam.startTraining();
        
        if (raam.getNumberOfTestingSamples() > 0) testButt.setEnabled(true);
        
        tfTrainSamps.setText(raam.getNumberOfTrainingSamples() + "");
        tfTestSamps.setText(raam.getNumberOfTestingSamples() + "");
      }
    }
    else if (cmd.equalsIgnoreCase("start_testing"))
    {
      if (parseInputfields())
      {
        raam.startTesting();
      }
    }
    else if (cmd.startsWith("load"))
    {
      loadDataset(cmd);
      
      this.tf_hiddenNodes.setText(12 + "");
      this.tf_outputNodes.setText(36 + "");
      this.tf_inputNodes.setText(36  + "");
    }
    else if (cmd.startsWith("save"))
    {
      raam.saveMe("save/decoder");
    }
    else if (cmd.startsWith("getfromfile"))
    {
      trainButt.setEnabled(true);
      
      raam = new RAAM(this);
      NetworkPool.setDecoderNetwork(raam);
      
      annConfig = raam.loadMe("save/decoder");
      setLoadedConfig();
      // raam.extractTrainingStructures();
    }
  }
//---------------------------------------------------------------------//
}