package sharkey_mod_nlp.gui;

import java.awt.event.ActionEvent;
import javax.swing.*;

import sharkey_mod_nlp.fnn.FNN;
import sharkey_mod_nlp.fnn.NetworkPool;
import sharkey_mod_nlp.fnn.SRN;

public class GUI_SRN extends GUI_ANN
{
  private SRN nm;
  private JButton jbCreate;
  
  public GUI_SRN()
  {
    tf_inputNodes.setText("135");
    tf_hiddenNodes.setText("50");
    tf_outputNodes.setText("85");
    
    tf_inputNodes.setEditable(true);
    
    jbCreate = new JButton("CREATE DATA!");
    jbCreate.setActionCommand("create");
    jbCreate.addActionListener(this);
    
    add(jbCreate);
    jbCreate.setEnabled(false);
  }
//---------------------------------------------------------------------//  
  public void actionPerformed(ActionEvent e)
  {
    String cmd = e.getActionCommand();
    
    // -------- tmp just for generation of dataset
    if (cmd.equalsIgnoreCase("create"))
    {
      nm = new SRN(this, annConfig);
      nm.generateSentences();
    }
    //-------------
    
    if (cmd.equalsIgnoreCase("makenetwork"))
    {
      if (parseInputfields())
      {
        trainButt.setEnabled(true);
        
        nm = new SRN(this, annConfig);
        NetworkPool.setEncoderNetwork(nm);
      }
    }
    else if (cmd.equalsIgnoreCase("start_training"))
    {
      if (parseInputfields())
      {
        trainButt.setEnabled(true);
        
        nm.startTraining();
        if (nm.getNumberOfTestingSamples() > 0) testButt.setEnabled(true);
        
        tfTrainSamps.setText(nm.getNumberOfTrainingSamples() + "");
        tfTestSamps.setText(nm.getNumberOfTestingSamples() + "");
      }
    }
    else if (cmd.equalsIgnoreCase("start_testing"))
    {
      if (parseInputfields())
      {
        nm.startTesting();
      }
    }
    else if (cmd.startsWith("load"))
    {
      loadDataset(cmd);
      
      int outN = dataset.getLexicon().getWordsInDictionary().size();
      int hidN = 50;
      
      this.tf_hiddenNodes.setText(hidN + "");
      this.tf_outputNodes.setText(outN + "");
      this.tf_inputNodes.setText(outN + hidN + "");
    }
    else if (cmd.startsWith("save"))
    {
      nm.saveMe("save/encoder");
    }
    else if (cmd.startsWith("getfromfile"))
    {
      trainButt.setEnabled(true);
      
      nm = new SRN(this);
      NetworkPool.setEncoderNetwork(nm);
      
      annConfig = nm.loadMe("save/encoder");
      setLoadedConfig();
      nm.createSuccessorTables();
    }
  }
//---------------------------------------------------------------------//
}