package sharkey_mod_nlp.gui;

import java.awt.event.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;

import sharkey_mod_nlp.fnn.*;
import sharkey_mod_nlp.gui.tree.TreeCanvas;
import sharkey_mod_nlp.gui.tree.TreeFrame;
import sharkey_mod_nlp.dataset.*;
import sharkey_mod_nlp.treemodel.*;

public class GUI_TEST extends JPanel implements ActionListener
{
  private JButton runButt;
  private SRN encoder;
  private FNN mapper;
  private RAAM decoder;
//------------------------------------------------------------------------//
  public GUI_TEST()
  {
    runButt = new JButton("TestIt");
    runButt.addActionListener(this);
    runButt.setActionCommand("testit");
    
    add(new JLabel("Run using training data"));
    add(runButt);
  }
//------------------------------------------------------------------------//
  public void actionPerformed(ActionEvent e)
  {
    if (e.getActionCommand().equalsIgnoreCase("testit"))
    {
      encoder = NetworkPool.getEncoderNetwork();
      mapper  = NetworkPool.getMapperNetwork();
      decoder = NetworkPool.getDecoderNetwork();
      
      Vector<Instance> trainData = encoder.getTrainingData();
      
      double[] srnResult, mapResult;
      ParseNode parseTree;      
      Instance instance;
      
      for (int i=0; i < trainData.size(); i++)
      {
        instance   = trainData.elementAt(i);
        srnResult  = encoder.testThisInput(instance);
        mapResult  = mapper.mapThisPattern(srnResult);      
        parseTree  = decoder.decodeThisPattern(mapResult, instance.getClassID());
        
        showTree(parseTree);
      }
    }
  }
//------------------------------------------------------------------------//  
  private void showTree(ParseNode root)
  {
    Spatializer spz   = new Spatializer(new Tree<IGenericNode>(root), 45, 45, 14, 14);
    TreeCanvas canvas = new TreeCanvas(spz, false);
    TreeFrame tf      = new TreeFrame("Decoded parsetree - classID = " + root.getSyntacticStructureID(), canvas);
    tf.setDefaultCloseOperation(javax.swing.JFrame.HIDE_ON_CLOSE);
    tf.setVisible(true);
  }
}
//------------------------------------------------------------------------//