package sharkey_mod_nlp.treemodel;

import java.util.Vector;
import java.awt.Color;

public interface IGenericNode
{
	////////////////////////////////////////////////////////
	/// basic methods for get/setting meta-data from a node
	public abstract int getPly();	
	public abstract int getMaxPlyDepth();
	public abstract IGenericNode getParent();
	public abstract boolean isLeafNode();
	public abstract boolean isRoot();
	
	//////////////////////////////////////////////////////////
	/// various methods of get/setting the contents of a node
	public abstract Object       getContent();
	public abstract int          getIntegerValue();
	public abstract String[]     getTextualValue();
	
	public abstract Vector<IGenericNode> getChildren();
	
	public abstract void setIntegerValue(int value);
	public abstract void setTextualValue(String[] value);  
	public abstract void addChild(IGenericNode node);
}
