package sharkey_mod_nlp.treemodel;

import java.util.Vector;

public class Tree<E>
{
	private IGenericNode root;
	
	public Tree(E rootNode)
	{
		root = (IGenericNode)rootNode;
	}	
//----------------------------------------------------// 
	public E getRoot()
	{
		return (E)root;
	}
//----------------------------------------------------//
  public Vector<E> getLeafNodes()
  {
    Vector<E> leafNodes = new Vector<E>();
    
    suckoutNodes(root, leafNodes, true);
    
    return leafNodes;
  }
//----------------------------------------------------//
	public Vector<E> getAllNodes()
	{
		Vector<E> allNodes = new Vector<E>();
		
		allNodes.addElement((E)root);		
		suckoutNodes(root, allNodes, false);
		
		return allNodes;
	}
//----------------------------------------------------//
  // public Vector<IGenericNode>[] getNodesAsPly_Arrays()
  public Vector<E>[] getNodesAsPly_Arrays()
  {
  	Vector<E>[] allPlys = new Vector[root.getMaxPlyDepth() + 1];
  	
  	for (int i=0; i < allPlys.length; i++) allPlys[i] = new Vector<E>();
  	
  	allPlys[root.getPly()].addElement((E)root);
  	traverseTree(root, allPlys);

  	return allPlys;
  }
//----------------------------------------------------//
  private void suckoutNodes(IGenericNode node, Vector<E> allNodes, boolean leafNodesOnly)
  {
  	Vector<IGenericNode> children = node.getChildren();
  	IGenericNode child;
  	
  	for (int i=0; i < children.size(); i++)
  	{
  		child = children.elementAt(i);
  		
      if (leafNodesOnly)
      {
        if (child.isLeafNode()) allNodes.addElement((E)child);
      }
      else
      {
        allNodes.addElement((E)child);
      }
 			suckoutNodes(child, allNodes, leafNodesOnly);
  	}
  }
//----------------------------------------------------//
  private void traverseTree(IGenericNode node, Vector<E>[] allPlys)
  {
  	Vector<IGenericNode> children = node.getChildren();
  	IGenericNode child;
  	
  	for (int i=0; i < children.size(); i++)
  	{
  		child = children.elementAt(i);
			allPlys[child.getPly()].addElement((E)child);
 			traverseTree(child, allPlys);
  	}
  }
//----------------------------------------------------//
}
