package nasseutils;

import java.awt.*;
import javax.swing.*;

//-===================================================================================-//
public class NasseBox extends JPanel
{
  private static final int BORDER = 10;
  private JPanel componentPanel;
  // private JLabel label;
  // private String title;

  public NasseBox(String title)
  {
    super(new FlowLayout(FlowLayout.CENTER, BORDER, BORDER));
    super.setLayout(new FlowLayout(FlowLayout.CENTER, BORDER, BORDER));
    
    componentPanel = new JPanel(new FlowLayout(FlowLayout.CENTER));
    super.add(componentPanel);

    /*
    this.title = title;
    if (title != null) label = new JLabel(title);
    */    
  }
//-===================================================================================-//
  public void setLayoutX(LayoutManager layout)
  {
    componentPanel.setLayout(layout);
  }
//-===================================================================================-//
  public JComponent add(JComponent c)
  {
     componentPanel.add(c);
     return c;
  }
//-===================================================================================-//
  public JComponent add(JComponent c, int index)
  {
     componentPanel.add(c, index);
     return c;
  }
//-===================================================================================-//
  public void paint(Graphics g)
  {
    super.paint(g);
    
    Color light  = this.getBackground().brighter();
    Color dark   = this.getBackground().darker();
    
    // Horiz TOP
    g.setColor(dark);
    g.drawLine(0, 0, getWidth()-2, 0);
    g.setColor(light);
    g.drawLine(1, 1, getWidth()-3, 1); 

    // Horiz BOTTOM
    g.setColor(dark);
    g.drawLine(0, getHeight()-2, getWidth()-2, getHeight()-2);
    g.setColor(light);
    g.drawLine(0, getHeight()-1, getWidth()-1, getHeight()-1);

    // Vertic LEFT
    g.setColor(dark);
    g.drawLine(0, 0, 0, getHeight()-2);
    g.setColor(light);
    g.drawLine(1, 1, 1, getHeight()-3);

    // Vertic RIGHT
    g.setColor(dark);
    g.drawLine(getWidth()-2, 0, getWidth()-2, getHeight()-2);
    g.setColor(light);
    g.drawLine(getWidth()-1, 0, getWidth()-1, getHeight()-1);
  }
//-===================================================================================-//
  public void update(Graphics g)
  {
    paint(g);
  }
//-===================================================================================-//
}

