package sfm.gui;

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.io.*;
import java.util.*;

import sfm.shp.LabelData;
import sfm.shp.PixelData;
import sfm.shp.ShapeData;
import sfm.shp.network.*;

import sfm.dataset.Dataset;
import sfm.dataset.Instance;
import sfm.gui.ImagePanel;
import sfm.dataset.input.ReadFile;

import nasseutils.NasseBox;

public class GUI_LABELS extends GUI_SHELL implements ActionListener, ItemListener
{
  public GUI_LABELS()
  {
    annConfig = new ANNConfig(9, 14, 8);
    network   = new FNN(this, annConfig, "words");
    labelV    = new Vector<LabelData>();    
    loadLabels();    
    addDatasetToLabelNet();
    
    createNetworkButt.addActionListener(this);
    trainButt.addActionListener(this);
    testButt.addActionListener(this);
    saveButt.addActionListener(this);
    loadButt.addActionListener(this);
    
    this.tf_Epochs.setText("6500");
    
    this.tf_inputNodes.setText(LabelData.getPatternLength() + "");
    this.tf_hiddenNodes.setText("14");
    this.tf_outputNodes.setText(labelV.size() + "");
    
    this.tf_Learningrate.setText("0.35");
    this.tf_margin.setText("0.1");
    this.tf_Momentum.setText("0.75");
    this.tf_Noise.setText("0.0");    
  }
//-----------------------------------------------------------------//
  private void addDatasetToLabelNet()
  {
    LabelData labelD;
    Instance inst;    
    Dataset ds = new Dataset("Labels", labelV.size());
    
    for (int i=0; i < labelV.size(); i++)
    {
      labelD = labelV.elementAt(i);
      inst   = new Instance(labelD.getLabel(), labelD.getPattern(), labelD.getLabelID(), labelD.getTrainingTarget());
     
      ds.addInstance(inst);
    }
    network.setDataset(ds);
    annConfig.setDataset(ds);
  }
//---------------------------------------------------------------------//  
  public void actionPerformed(ActionEvent e)
  {
    String cmd = e.getActionCommand();
    
    // check for whatever special actions for this net....
    // if none, call the super.actionPerformed()    
    //... checks
    
    if (cmd.equalsIgnoreCase("Weeeeeeeee!"))
    {
      // do whatever
      
      return;
    } 
    
    super.actionPerformed(e);
  }
//---------------------------------------------------------------------//
}