package sfm.gui;

import java.awt.event.ActionEvent;
import java.util.Vector;

import sfm.dataset.Dataset;
import sfm.dataset.Instance;
import sfm.dataset.input.ReadFile;
import sfm.shp.LabelData;
import sfm.shp.RelLocDataH;
import sfm.shp.ShapeData;
import sfm.shp.network.ANNConfig;
import sfm.shp.network.FNN;

public class GUI_LOCATIONS_H  extends GUI_SHELL
{
  public GUI_LOCATIONS_H()
  {
    lociH      = new Vector<RelLocDataH>();
    annConfig  = new ANNConfig(4, 36, 10);
    network    = new FNN(this, annConfig, "location_horizontal");
    shapeV     = new Vector<ShapeData>();
    shapeFiles = ReadFile.getFilesInDir(shapeDir, this);    
    
    addDatasetToLocationNet();
    
    createNetworkButt.addActionListener(this);
    trainButt.addActionListener(this);
    testButt.addActionListener(this);
    saveButt.addActionListener(this);
    loadButt.addActionListener(this);
    
    this.tf_Epochs.setText("8500");
    
    this.tf_inputNodes.setText(RelLocDataH.getPatternWidth() + "");
    this.tf_hiddenNodes.setText("36");
    this.tf_outputNodes.setText(10 + "");
    
    this.tf_Learningrate.setText("0.15");
    this.tf_margin.setText("0.1");
    this.tf_Momentum.setText("0.65");
    this.tf_Noise.setText("0.0");
    
    annConfig.setUseAdaptiveLearningRate(cb_adaptiveLR.isEnabled());    
    annConfig.setUpdateWeightsPerEpoch(cb_updating.isEnabled());
  }
//---------------------------------------------------------------------//
  private void addDatasetToLocationNet()
  {
    // make the location data
    int sceneWidth  = 192;
    int shapeWidth  = 32;
    int horizLoci   = (int) ((double)sceneWidth  / (double)shapeWidth);
    
    int x1, x2;
    
    // Create all (36) possible positions, horizontal...
    for (int i=0; i < horizLoci; i++)
    {
      x2 = (i * shapeWidth);
      for (int j=0; j < horizLoci; j++)
      {
        x1 = (j * shapeWidth);
        lociH.addElement(new RelLocDataH(x1, x2));
      }
    }
    //------------------------------------------------------------
    
    RelLocDataH loc;
    Instance instH;    
    Dataset ds = new Dataset("Locations", 5);
    
    for (int i=0; i < lociH.size(); i++)
    {
      loc   = lociH.elementAt(i);
      instH = new Instance(loc.getPreposition_x1_to_x2()+"/"+loc.getPreposition_x2_to_x1(), loc.getPattern(), loc.getClassID(), loc.getTrainingtarget());
      
      ds.addInstance(instH);  
      // ds.addInstance(instV);
    }
    network.setDataset(ds);
    annConfig.setDataset(ds);
  }
//---------------------------------------------------------------------//
  public void actionPerformed(ActionEvent e)
  {
    String cmd = e.getActionCommand();
    
    // check for whatever special actions for this net....
    
    
    super.actionPerformed(e);
  }
//---------------------------------------------------------------------//
}