package sfm.gui;

import java.awt.event.ActionEvent;
import java.util.Vector;

import sfm.dataset.Dataset;
import sfm.dataset.Instance;
import sfm.dataset.input.ReadFile;
import sfm.shp.LabelData;
import sfm.shp.RelLocDataV;
import sfm.shp.ShapeData;
import sfm.shp.network.ANNConfig;
import sfm.shp.network.FNN;

public class GUI_LOCATIONS_V  extends GUI_SHELL
{
  public GUI_LOCATIONS_V()
  {
    lociV      = new Vector<RelLocDataV>();
    annConfig  = new ANNConfig(4, 36, 10);
    network    = new FNN(this, annConfig, "location_vertical");
    shapeV     = new Vector<ShapeData>();
    shapeFiles = ReadFile.getFilesInDir(shapeDir, this);    
    
    addDatasetToLocationNet();
    
    createNetworkButt.addActionListener(this);
    trainButt.addActionListener(this);
    testButt.addActionListener(this);
    saveButt.addActionListener(this);
    loadButt.addActionListener(this);
    
    this.tf_Epochs.setText("8500");
    
    this.tf_inputNodes.setText(RelLocDataV.getPatternWidth() + "");
    this.tf_hiddenNodes.setText("36");
    this.tf_outputNodes.setText(10 + "");
    
    this.tf_Learningrate.setText("0.15");
    this.tf_margin.setText("0.1");
    this.tf_Momentum.setText("0.65");
    this.tf_Noise.setText("0.0");
    
    annConfig.setUseAdaptiveLearningRate(cb_adaptiveLR.isEnabled());    
    annConfig.setUpdateWeightsPerEpoch(cb_updating.isEnabled());
  }
//---------------------------------------------------------------------//
  private void addDatasetToLocationNet()
  {
    // make the location data
    int sceneHeight  = 192;
    int shapeHeight = 32;
    int verticLoci  = (int) ((double)sceneHeight  / (double)shapeHeight);
    
    int y1, y2;
    
    // Create all (36) possible positions, horizontal...
    for (int i=0; i < verticLoci; i++)
    {
      y2 = (i * shapeHeight);
      for (int j=0; j < verticLoci; j++)
      {
        y1 = (j * shapeHeight);
        lociV.addElement(new RelLocDataV(y1, y2));
      }
    }
    //------------------------------------------------------------
    
    RelLocDataV loc;
    Instance instV;    
    Dataset ds = new Dataset("Locations", 5);
    
    for (int i=0; i < lociV.size(); i++)
    {
      loc   = lociV.elementAt(i);
      instV = new Instance(loc.getPreposition_y1_to_y2()+"/"+loc.getPreposition_y2_to_y1(), loc.getPattern(), loc.getClassID(), loc.getTrainingtarget());
      
      ds.addInstance(instV);  
    }
    network.setDataset(ds);
    annConfig.setDataset(ds);
  }
//---------------------------------------------------------------------//
  public void actionPerformed(ActionEvent e)
  {
    String cmd = e.getActionCommand();
    
    // check for whatever special actions for this net....
    
    super.actionPerformed(e);
  }
//---------------------------------------------------------------------//
}