package sfm.gui;

import java.awt.event.*;
import java.awt.*;
import javax.swing.*;
import javax.swing.border.*;
import java.io.*;
import java.util.*;

import sfm.shp.LabelData;
import sfm.shp.PixelData;
import sfm.shp.ShapeData;
import sfm.shp.network.*;

import sfm.dataset.Dataset;
import sfm.dataset.Instance;
import sfm.gui.ImagePanel;
import sfm.dataset.input.ReadFile;

import nasseutils.NasseBox;

public class GUI_SHAPES extends GUI_SHELL implements ActionListener, ItemListener
{
  public GUI_SHAPES()
  {
    annConfig  = new ANNConfig(240, 36, 8);
    network    = new FNN(this, annConfig, "shapes");
    shapeV     = new Vector<ShapeData>();
    shapeFiles = ReadFile.getFilesInDir(shapeDir, this);    
    loadShapes();    
    addDatasetToShapeNet();
    
    createNetworkButt.addActionListener(this);
    trainButt.addActionListener(this);
    testButt.addActionListener(this);
    saveButt.addActionListener(this);
    loadButt.addActionListener(this);
    
    this.tf_Epochs.setText("350");
    
    this.tf_inputNodes.setText(ShapeData.getPatternLength(2) + "");
    this.tf_hiddenNodes.setText("36");
    this.tf_outputNodes.setText(shapeV.size() + "");
    
    this.tf_Learningrate.setText("0.15");
    this.tf_margin.setText("0.1");
    this.tf_Momentum.setText("0.65");
    this.tf_Noise.setText("0.0");
    
    annConfig.setUseAdaptiveLearningRate(cb_adaptiveLR.isEnabled());    
    annConfig.setUpdateWeightsPerEpoch(cb_updating.isEnabled());
  }
//---------------------------------------------------------------------//
  private void addDatasetToShapeNet()
  {
    // use training a scheme that classifies shapes by classID
    ShapeData shp;
    Instance inst;    
    Dataset ds = new Dataset("Shapes", shapeV.size());
    
    for (int i=0; i < shapeV.size(); i++)
    {
      shp  = shapeV.elementAt(i);
      inst = new Instance(shp.getShapeName(), shp.getPattern(true), shp.getShapeID(), shp.getTrainingTarget());
      
      ds.addInstance(inst);  
    }
    network.setDataset(ds);
    annConfig.setDataset(ds);
  }
//---------------------------------------------------------------------//  
  public void actionPerformed(ActionEvent e)
  {
    String cmd = e.getActionCommand();
    
    // check for whatever special actions for this net....
    // if none, call the super.actionPerformed()    
    //... checks
    
    if (cmd.equalsIgnoreCase("Weeeeeeeee!"))
    {
      // do whatever
      
      return;
    }
    
    super.actionPerformed(e);
  }
//---------------------------------------------------------------------//  
    
//---------------------------------------------------------------------//
}