package sfm.scene;

import sfm.shp.*;

import java.util.*;
import java.awt.*;
import java.awt.image.*;
import javax.swing.*;
import javax.swing.border.*;

public class Scene
{
  private int width, height, cols, rows, posRes; 
  private SceneComponent[][] sceneContent;
  
  public Scene(int w, int h, int res)
  {
    width        = w;
    height       = h;
    posRes       = res;
    cols         = width  / posRes;
    rows         = height / posRes;
    sceneContent = new SceneComponent[rows][cols];
  }
//--------------------------------------------------//
  public void addComponent(ShapeData shp, int row, int col)
  {
    sceneContent[row][col] = new SceneComponent(shp, col*posRes, row*posRes);
  }
//--------------------------------------------------//
  public ShapeData getSampleFrom(int row, int col)
  {
    if (sceneContent[row][col] != null)
    {
      return sceneContent[row][col].getShape();
    }
    return null;
  }
//--------------------------------------------------//
  public int getHorizontalLocations()
  {
    return cols;
  }
//--------------------------------------------------//
  public int getPositionOf(int cell)
  {
    return cell * posRes;
  }
//--------------------------------------------------//
  public int getVerticalLocations()
  {
    return rows;
  }
//--------------------------------------------------//
  
//--------------------------------------------------//
}


//-==================================================-//
//----- class SceneComponent ------------
//-==================================================-//
final class SceneComponent
{
  private int x,y;
  private ShapeData shape;
  
  public SceneComponent(ShapeData shp, int x, int y)
  {
    this.x   = x;
    this.y   = y;
    shape    = shp;
  }
//----------------------------------------------------//  
  public ShapeData getShape()
  {
    return shape;
  }
//----------------------------------------------------//
//----------------------------------------------------//
}