package sfm.shp;

import java.awt.Color;
import sfm.gui.GUI_SHELL;

public class RelLocDataH
{
  private static final int PREP_CLASS_LEFT  = 0x00;
  private static final int PREP_CLASS_RIGHT = 0x01;
  private static final int PREP_CLASS_ON    = 0x02;
  //------------------------------------------------
  private static final int PATTERNWIDTH = 0x04;
  
  private static int LOC_CNT      = 0x00;
  private static double MAX_X     = 0x00;
  
  private double[] pattern, tt;
  private double x1, x2;

  private int locNo, classID, classID_opposing;
  private String locName1, locName2;
  
  public RelLocDataH(int x11, int x22)
  {
    locNo = LOC_CNT++;
    
    this.x1 = x11;
    this.x2 = x22;
    
    locName1 = ""; 
    locName2 = "";
    
    pattern  = null;
    tt       = null;
    
    if (x1 > MAX_X) MAX_X = x1;
    if (x2 > MAX_X) MAX_X = x2;
    
    compile();
  }
//--------------------------------------------------------------------//
  public static int getPatternWidth()
  {
    return PATTERNWIDTH;
  }
//--------------------------------------------------------------------//
  public int getIdNumber()
  {
    return locNo;
  }
//--------------------------------------------------------------------//
  /**
   * returns the class of this prep. location w/ respect to the horizontal relation 
   */
  public int getClassID()
  {
    return classID;
  }
//--------------------------------------------------------------------//
  private void compile()
  {
    if (x1 > x2)
    {
      locName1 = "RIGHT";
      locName2 = "LEFT";
      
      classID          = RelLocDataH.PREP_CLASS_RIGHT;
      classID_opposing = RelLocDataH.PREP_CLASS_LEFT;
    }
    else if (x1 < x2)
    {
      locName1 = "LEFT";
      locName2 = "RIGHT";
      
      classID          = RelLocDataH.PREP_CLASS_LEFT;
      classID_opposing = RelLocDataH.PREP_CLASS_RIGHT;
    }
    else if (x1 == x2)
    {
      locName1 = "ON";
      locName2 = "ON";
      
      classID          = RelLocDataH.PREP_CLASS_ON;
      classID_opposing = RelLocDataH.PREP_CLASS_ON;
    }    
  }
//--------------------------------------------------------------------//
  public double[] getTrainingtarget()
  {
    tt = new double[5*2]; // 5 prepositions, binary relation --> 2 per prep.
    
    for (int i=0; i < 5; i++)
    {
      if (i == classID) tt[i] = 1.0;
      else tt[i] = 0.0;
    }
    
    int idx = 0;
    for (int i=5; i < tt.length; i++)
    {
      if (idx++ == classID_opposing) tt[i] = 1.0;
      else tt[i] = 0.0;
    }
    
    return tt;
  }
//--------------------------------------------------------------------//
  /**
   * Patterns with ONLY the horizontal component, pairs of x-values
   * Prepositions: above,below,on
   */
  public double[] getPattern()
  {
    pattern = new double[4];
    
    pattern[0] = (x1 / MAX_X); 
    pattern[1] = (x1 / MAX_X);
    pattern[2] = (x2 / MAX_X); 
    pattern[3] = (x2 / MAX_X);
    
    return pattern;
  }
//--------------------------------------------------------------------//
  public String getPreposition_x1_to_x2() 
  { 
    return locName1; 
  }
//--------------------------------------------------------------------//
  public String getPreposition_x2_to_x1() 
  { 
    return locName2; 
  }
//--------------------------------------------------------------------//
  public int getX1()     { return (int)x1; }
  public int getX2()     { return (int)x2; }
//--------------------------------------------------------------------//
  public String toString()
  {
    String str = "";
    
    if (pattern != null && tt != null)
    {
      str = locName1 + ":" + classID + "\n";
      str += GUI_SHELL._printArray("pattern: ", pattern, 2);
      str += GUI_SHELL._printArray("tt     : ", tt, 2);
    }
    
    return str;
  }
//--------------------------------------------------------------------//
}
