package sfm.shp;

import java.awt.Color;
import sfm.gui.GUI_SHELL;

public class RelLocDataV
{
  private static final int PREP_CLASS_ABOVE  = 0x00;
  private static final int PREP_CLASS_BELOW  = 0x01;
  private static final int PREP_CLASS_ON     = 0x02;
  //------------------------------------------------
  private static final int PATTERNWIDTH = 0x04;
  
  private static int LOC_CNT      = 0x00;
  private static double MAX_Y     = 0x00;
  
  private double[] pattern, tt;
  private double y1, y2;

  private int locNo, classID, classID_opposing;
  private String locName1, locName2;
  
  public RelLocDataV(int y11, int y22)
  {
    locNo = LOC_CNT++;
    
    this.y1 = y11;
    this.y2 = y22;
    
    locName1 = ""; 
    locName2 = "";
    
    pattern  = null;
    tt       = null;
    
    if (y1 > MAX_Y) MAX_Y = y1;
    if (y2 > MAX_Y) MAX_Y = y2;
    
    compile();
  }
//--------------------------------------------------------------------//
  public static int getPatternWidth()
  {
    return PATTERNWIDTH;
  }
//--------------------------------------------------------------------//
  public int getIdNumber()
  {
    return locNo;
  }
//--------------------------------------------------------------------//
  /**
   * returns the class of this prep. location w/ respect to the horizontal relation 
   */
  public int getClassID()
  {
    return classID;
  }
//--------------------------------------------------------------------//
  private void compile()
  {
    if (y1 > y2)
    {
      locName1 = "BELOW";
      locName2 = "ABOVE";
      
      classID          = RelLocDataV.PREP_CLASS_BELOW;
      classID_opposing = RelLocDataV.PREP_CLASS_ABOVE;
    }
    else if (y1 < y2)
    {
      locName1 = "ABOVE";
      locName2 = "BLEOW";
      
      classID          = RelLocDataV.PREP_CLASS_ABOVE;
      classID_opposing = RelLocDataV.PREP_CLASS_BELOW;
    }
    else if (y1 == y2)
    {
      locName1 = "ON";
      locName2 = "ON";
      
      classID          = RelLocDataV.PREP_CLASS_ON;
      classID_opposing = RelLocDataV.PREP_CLASS_ON;
    }    
  }
//--------------------------------------------------------------------//
  public double[] getTrainingtarget()
  {
    tt = new double[5*2]; // 5 prepositions, binary relation --> 2 per prep.
    
    for (int i=0; i < 5; i++)
    {
      if (i == classID) tt[i] = 1.0;
      else tt[i] = 0.0;
    }
    
    int idx = 0;
    for (int i=5; i < tt.length; i++)
    {
      if (idx++ == classID_opposing) tt[i] = 1.0;
      else tt[i] = 0.0;
    }
    
    return tt;
  }
//--------------------------------------------------------------------//
  /**
   * Patterns with ONLY the horizontal component, pairs of x-values
   * Prepositions: above,below,on
   */
  public double[] getPattern()
  {
    pattern = new double[4];
    
    pattern[0] = (y1 / MAX_Y); 
    pattern[1] = (y1 / MAX_Y);
    pattern[2] = (y2 / MAX_Y); 
    pattern[3] = (y2 / MAX_Y);
    
    return pattern;
  }
//--------------------------------------------------------------------//
  public String getPreposition_y1_to_y2() 
  { 
    return locName1; 
  }
//--------------------------------------------------------------------//
  public String getPreposition_y2_to_y1() 
  { 
    return locName2; 
  }
//--------------------------------------------------------------------//
  public int getY1()     { return (int)y1; }
  public int getY2()     { return (int)y2; }
//--------------------------------------------------------------------//
  public String toString()
  {
    String str = "";
    
    if (pattern != null && tt != null)
    {
      str = locName1 + ":" + classID + "\n";
      str += GUI_SHELL._printArray("pattern: ", pattern, 2);
      str += GUI_SHELL._printArray("tt     : ", tt, 2);
    }
    return str;
  }
//--------------------------------------------------------------------//
}
